﻿using FarmingSimulator.Fruits;

namespace FarmingSimulator;

class EatingVisitor : IEdibleVisitor {
	public void Visit(IEdible edible) {
		Console.WriteLine($"EatingVisitor: Edible {edible.GetType().Name} eaten, player got {edible.Energy} units of energy.");
	}

	public void Visit(GoldenApple goldenApple) {
		this.Visit((IEdible) goldenApple);
		Console.WriteLine("EatingVisitor: Golden apple increased player's luck.");
	}

	public void Visit(NoseGrowingApple noseGrowingApple) {
		this.Visit((IEdible) noseGrowingApple);
		Console.WriteLine("EatingVisitor: Player's nose got 100-times longer.");
	}
}